Subject: Re: bug#60340: 29.0.60; force-mode-line-update does not update tab line

From: Aaron Jensen <[email-masked]>
Date: Mon, 26 Dec 2022 12:55:11 -0500

On Mon, Dec 26, 2022 at 12:04 PM Eli Zaretskii <[email-masked]> wrote:
>
> > From: Aaron Jensen <[email-masked]>
> > Date: Mon, 26 Dec 2022 11:40:33 -0500
> >
> >
> > (defun random-name (_buffer &optional _buffers)
> >   (format "tab %d" (random 1000)))
> > (setq tab-line-tab-name-function #'random-name)
> > (tab-line-mode)
> >
> > Then, eval:
> >
> > (force-mode-line-update)
> >
> > Every time that evals, I believe you should see the tab name update, but
> > it does not. This makes it impossible to change tab names without
> > changing buffer names as far as I can tell. There is likely something
> > I'm missing, but per the docs, I believe force-mode-line-update should
> > update tab lines. Passing `t' as ALL does not work either.
>
> force-mode-line-update updates what's displayed on the line, but it
> doesn't recompute tab-line-format.  And that is what you want to do:
> you customize tab-line-tab-name-function, which affects
> tab-line-format.
>
> IOW, if your format has %d, and %d formats some number which changes
> with time, then you can expect that force-mode-line-update will cause
> a different string be displayed instead of %d.  But you _cannot_
> expect that the format string which includes %d will be recalculated
> just because you called force-mode-line-update.
>
> If you want the displayed values to change when the line is
> redisplayed, you need to use :eval or somesuch.

It uses :eval out of the box. The problem was the cache as Juri pointed out.

On Mon, Dec 26, 2022 at 12:35 PM Juri Linkov <[email-masked]> wrote:
>
>
> (defun tab-line-cache-key-default (_tabs)
>   (list (random 1000)))

Thank you for the pointer! I can do this and it works great:

(set-window-parameter nil 'tab-line-cache nil)
(force-mode-line-update)